#if	!defined( __FNMATCH_H )
#define	__FNMATCH_H

#if	defined( __cplusplus )
extern "C" {
#endif

/*
 * Bits set in the FLAGS argument to `fnmatch'.
 */

#define	FNM_PATHNAME	(1 << 0) /* No wildcard can ever match `/'.	    */
#define	FNM_NOESCAPE	(1 << 1) /* Backslashes don't quote special chars.  */
#define	FNM_PERIOD	(1 << 2) /* Leading `.' is matched only explicitly. */

#if	!defined( _POSIX_C_SOURCE ) || _POSIX_C_SOURCE < 2
#define	FNM_CASEFOLD	(1 << 3) /* Compare without regard to case.	    */
#endif

/*
 * Value returned by `fnmatch' if STRING does not match PATTERN.
 */

#define	FNM_NOMATCH	1

/*
 * Match STRING against the filename pattern PATTERN,  returning zero
 * if it matches, FNM_NOMATCH if not.
 */

extern int fnmatch( const char *pattern, const char *string, int flags );

#if	defined( __cplusplus )
}
#endif

#endif /* _FNMATCH_H */
